# B.A.E. Mod : BadAssEngi
#### By iDeathHD / Violet Chaolan

A mod that makes the Engineer Bad Ass.

### Video Showcase

- [![Bad Ass Engi Mod Showcase](http://img.youtube.com/vi/M4ux2QqW5cU/0.jpg)](https://www.youtube.com/watch?v=M4ux2QqW5cU "Bad Ass Engi Mod Showcase")

- [Bad Ass Engi Vaporwave Edition - Back to the 80s](https://www.youtube.com/watch?v=WHmO9CCnzMU)

- [Old video showcasing other features like mines.](https://www.youtube.com/watch?v=-MKGLkgtmUc)

## Feature Highlight

### Keybinds

- Changing the type of turret. List of possible keybind at the end of this page : https://docs.unity3d.com/Manual/ConventionalGameInput.html
`Default value: f1`

- Changing the type of grenades.
`Default value: f3`

- Changing the type of mines.
`Default value: f4`

- Manually detonating satchel mines.
`Default value: c`

### Custom UI For Fortnite Emotes Menu

- Bottom right on the screen while playing should have a new button called `Emote Button` that will pop up a window for doing fortnite emotes.

- The window is resizeable and moveable.

- You can also use those console commands for playing the animations : 

- `bae_animation <animation_index>` and `bae_list_animation`

### Console commands

- **Change, enable or disable the custom color of your Bad Ass Engineer**. 

Usage : `bae_engi_color R G B` / `bae_engi_color enable/disable`. 

Exemple Usage : `bae_engi_color 7 76 3.75` . Or just `bae_engi_color` to force a color update across the network.

- Same for the turrets with `bae_turret_color` !

- Same for the missile tracker HUD with `bae_indicator_color` !

- Same for the cluster mine visuals with `bae_cluster_color` !

- For more info about any commands, type `help` followed by the command name (`help bae_cluster_color`) for an example on how to use.

- **Can quickly test modified config values in-game !** 

A config file called **BadAssEngi**.cfg located in the `BepInEx\config` folder should appear once you launch the game with the mod installed.

You can reload it while being ingame by using the console command `bae_reload`

Can change the volume of emote music with `bae_emote_volume`. Exemple usage : `bae_emote_volume 50` (range is 0-100)

### Installation Guide

- Copy `BadAssEngi` folder to your BepInEx plugins folder.

### Discord

- [We have a discord server. If you find a bug or would just like to be with people who share the same love with Engi, please join us.](https://discord.gg/Yk7Bgw7)

### Special Thanks

- Ryan Pallesen

- Mister_Name

- Перетащите был здесь

### Changelog

`1.3.7` - New visual for railgun turrets. Fix a bug where switching between satchel and cluster mines was putting the cooldown to 20 seconds and removed all stocks. Fix a bug where skill preferences for Bad Ass Engi were not saved to user profile.

`1.3.6` - Update for SOTV DLC1 Update. Multiplayer is untested, report issues in the discord if any.

`1.3.5` - Fix orbital mine that could be detonated manually and wouldn't properly execute the orbital strike. Fix swappable mines restoring the consumed charges when switching mine type.

`1.3.4` - Update for latest patch

`1.3.3` - Update for Anniversary Game Update.

`1.3.2` - Fix missing Orbital Strike sound. Fix Orbital Strike cooldown resetting across stages.

`1.3.1` - Forgot to remove a debug hook. Updated README, minirpclib is NOT needed anymore.

`1.3.0` - Bad Ass Engi should be way more mod compatibility friendly.

`1.2.9` - Turrets damage is now modified through damage %, not from base damage anymore. Fix an issue with the orbital strike sound not properly ending when exiting runs.

`1.2.8` - Fix the ResourcesAPI error at game start.

`1.2.7` - Update for the 1.0 game version.

`1.2.6` - Add a console command a config entry for changing the volume of the emote music. Console command is `bae_emote_volume`. Fix a compatibility issue with ExpandedSkills.

`1.2.5` - Fix a bug where Harpoon would reset the new skill variants introduced by Bad Ass Engi, like Orbital Strike. Fix UI that would go sometimes offscreen if you had a smaller resolution than `1920x1080`

`1.2.4` - Fix a bug where brainstalk buff would last indefinitly if your turret killed an elite. Make infusion stacks shared across engi and his turrets. Add BAE Discord link to README.

`1.2.3` - Fix a potential crash when switching stages. Add new emotes / songs.

`1.2.2` - Fix a bug where Engi would have a very strange skin when using emotes with specific items equipped.

`1.2.1` Release : 

- Various balance changes related to turrets : 
	- the default turret max distance default value is now 60 (same as vanilla)
	- Hydra Launcher Max targeting distance is now 40 (from 70).
	- Minigun Turret Max targeting distance is now 50.
- Fix a bug where the emote menu would persist after scene change and be unclosable.
- Add `bae_animation <animation_index>` and `bae_list_animation` so that you can play animations : 
	- Directly from the console
	- With macros/custom keybinds with for example this mod [MacroCommands](https://thunderstore.io/package/JackPendarvesRead/MacroCommands/) 
	- When using MacroCommands please know that you'll need [FluffyLabsConfigManagerTools](https://thunderstore.io/package/JackPendarvesRead/FluffyLabsConfigManagerTools/) and also [BepinexConfigurationManager](https://thunderstore.io/package/JackPendarvesRead/BepinexConfigurationManager/) installed.

`1.2.0` - Now with Fortnite Emotes.

`1.1.4` - Bad Ass Engi, vaporwave bouncy edition, surprise in the config file. Add new explosion effects for missiles / Hydra Launcher Turrets.

`1.1.3` - Fix a bug where bubble shield would be replaced by mines...

`1.1.2` - Add the currently used keybind in the relevant descriptions of the skills. Fix a bug with cluster mines dealing wrong amount of damage on the first use. :' )

`1.1.1` - Fix a bug where cluster mine simply wouldnt work... oops.

`1.1.0` Release :

- Fix a bug where orbital mines wouldn't work properly in multiplayer. 
- Seeker Missiles now have a Missile Tracker Indicator Interface that allow you to see the current target. 
- Seeker Missiles now prioritize target that you are currently aiming at. If you don't aim at any monster it'll seek the nearest monster as usual.
- Seeker Missiles Balance Value Change : Damage coefficient is now `22.5%` (from `25%`). Max projectile number is now `24` (from `16`)
- Add skill variants so that you can play with default mines or grenades or turret if you wish without having the ability to hot swap between the types.
- New visuals for the cluster mines. Should be way less laggy.
- Add the console commands `bae_cluster_color R G B` for cluster mines visual and `bae_indicator_color R G B` for the missile tracker HUD.

`1.0.4` - Updated for the Artifact Content Update, `bae_engi_color` and `bae_turret_color` may work incorrectly with the new skin selected.

`1.0.3` - Fixed the custom turret colors always being the one of the host.

`1.0.2` - Hopefully finally fixed a bug where mines wouldn't work properly in multiplayer.

`1.0.1` - Fixed a bug where mines wouldn't work properly in multiplayer.

`1.0.0` Release :

- New `video` by Violet Chaolan that shows the new features ! Check it out !
- Added `Orbital Strike Mine` as a mine skill variant, requires `100 stocks to be used`, with a `3 second cd for each charges`, and the cooldown is shared across stages (doesn't reset).
- Added a new turret type called `Hydra Launcher`, which is meant to be used for close range combat, shotgun style.
- Replaced the model of the seeker grenades with a custom model of missile (so now called Seeker Missile instead). Looks very cool. Model is also used for the `Hydra Launcher`.
- Upped the damage coefficient of the seeker missiles. It's now `25%` of Engi Damage (`12.5%` of damage before)

`0.2.4` - Added DPAD (controller) support for the keybinds of the mod. `dpadup` | `dpaddown` | `dpadleft` | `dpadright` are the only valid strings to use in the config file.

`0.2.3` - Fixed the turrets not working properly when using the mod in a Dedicated Server.

`0.2.2` - Fixed the config file not working properly. Safest is to delete the one you had if you started using Bad Ass Engi on the `0.2.0` release.

`0.2.1` - Fixed the sound of the seeker grenades not ending properly.

`0.2.0` - Updated for December Update. Updated Readme.

`0.1.9` - Fixed a bug where the spider mines were doing the wrong amount of damage. Fixed survivor catalog exception and updated AssetPlus dependency.

`0.1.8` - Fixed a bug where you couldn't use the inferior walking turrets while having this mod.

`0.1.7` - Fixed the turrets being named "Engineer Turret" instead of their supposed names.

`0.1.6` - Fixed the mines and shield not working in multiplayer.

`0.1.5` - **bae_engi_color enable/disable** is now a thing, same for **bae_turret_color**. Updated for the Skills 2.0 Game Update.

`0.1.4` - Hopefully fixed a bug where the Bazaar wouldn't load. Fixed an issue with Rex's special skill seed not getting removed properly.

`0.1.3` - Added a compatibility fix for Aether's CharacterCustomizer mod.

`0.1.2` - Hopefully fixed all the issues related to grenade sounds.

`0.1.1` - Fixed mines sounds not firing properly. Engineer color should correctly be changed when a run starts, if not, please use the command **bae_engi_color** in console. (without any parameters)

`0.1.0` - Added config options, and console commands, respectively **bae_engi_color** and **bae_turret_color** for changing colors. Updated sound effects. 

`0.0.9` - Updated **AssetPlus** dependency version.

`0.0.8` - Fixed Headhunter giving unlimited buffs duration between your turrets and yourself. Changed sounds of various things. Updated dependency to **AssetPlus**.

`0.0.7` - Changed the rebar color for turrets / mines. New sound for the minigun turret / railgun turret. Nerfed the damage of seeker grenades, from 0.5 damage coefficient to 0.125. (since its now firing 4 times the amount as before)

`0.0.6` - Reduced the proc coefficient of the minigun turret (configurable value, default to 50%). Fixed high attack speed clunkyness for firing grenades. One stack of seeker grenades now shot a minimum of 4 grenades, stacking up to 32 grenades at max stacks.

`0.0.5` - Fix for null ref exception in the console when an Engineer die while having his turrets still active.

`0.0.4` - Made the maximum numbers of rebar configurable, default to 700 (800 before), changed the sound of the minigun turret, reduced the damage coefficient of the cluster mines (halved), fixed buffs not updating correctly, removed the spread of the railgun turret.

`0.0.1` - Initial release of the mod.